var canvas;
var ctx;
var gctx;
var points = 0;
var point1X = 0;
var point1Y = 0;
var point2X = 0;
var point2Y = 0;
var ruler = 0;
var shiftKey = false;
var tempY;
var tempX;
var newTime;
var oldTime;

window.addEventListener( 'load', function() {
	if(( navigator.platform.toUpperCase() == "WIN32" || navigator.platform.toUpperCase() == "MACPPC" )) {
		ruler = 0;

		window.resizeTo( screen.width, screen.height );
		window.moveTo( 0, 0 );

		canvasElement = document.getElementById("c");
		canvasElement.setAttribute("width", screen.width );
		canvasElement.setAttribute("height", screen.height );
		canvasElement.onmousedown = putPoint;
		canvasElement.onmousemove = drawTempLine;	

		document.getElementById("lengths").onclick = putPoint;

		canvas = document.getElementById("c");
		ctx = canvas.getContext('2d');
		gctx = canvas.getContext('opera-2dgame');
	}
 	// Enable simple ruler for Linux
	else {
		ruler = 1;
		opera.postError( "Screen Ruler: simple ruler enabled" );

		// hide win32 ruler
		window.resizeTo( screen.width, 32 );
		window.moveTo( 0, ( screen.height / 2 ) );		

		document.getElementById("transp").style.display = "none";
		document.getElementById("notransp").style.display = "block";

		canvasElement = document.getElementById("d");
		canvasElement.setAttribute("width", screen.width );
		canvasElement.setAttribute("height", 40 );
		canvasElement.onmousedown = putPoint;
		canvasElement.onmousemove = drawTempLine;

		canvas = document.getElementById("d");
		ctx = canvas.getContext('2d');
		gctx = canvas.getContext('opera-2dgame');
	}
}, false );

function shift() {
	e = window.event;
	if( e.keyCode == 16 ) shiftKey = true;
}

function unShift() {
	e = window.event;
	if( e.keyCode == 16 ) shiftKey = false;
}

function putPoint() {
	e = window.event;

	if( points == 0) {
		point1X = e.x;
		point1Y = e.y;

		// draw point 1
		ctx.strokeStyle = "rgba(0, 0, 220, 1)";
		ctx.strokeRect( point1X - 2, point1Y - 2, 5, 5 );

		// show coords;
		p1Label = document.getElementById("p1Coords");
		p1Label.style.top = point1Y + 5;
		p1Label.style.left = point1X - 34;
		p1Label.innerHTML = "X=" + point1X + " Y=" + point1Y;
		p1Label.style.display = "block";

		points = 1;
	}
	else if( points == 1 ) {
		var xLen = point1X - e.x;
		if( xLen < 0 ) xLen = xLen * -1;

		var yLen = point1Y - e.y;
		if( yLen < 0 ) yLen = yLen * -1;
	
		if( !shiftKey ) {
			point2X = e.x;
			point2Y = e.y;
		}
		else {
			if( xLen > yLen ) {
				point2X = e.x;
				point2Y = point1Y;
			}
			else {
				point2X = point1X;
				point2Y = e.y;
			}
		}

		// draw point 2
		ctx.strokeStyle = "rgba(220, 0, 0, 1)";
	
		if( ruler == 0) ctx.strokeRect( point2X - 2, point2Y - 2, 5, 5 );
		else ctx.strokeRect( point2X - 2, point1Y - 2, 5, 5 );

		// show coords;
		p2Label = document.getElementById("p2Coords");
		p2Label.style.top = point2Y + 5;
		p2Label.style.left = point2X - 34;
		p2Label.innerHTML = "X=" + point2X + " Y=" + point2Y;
		p2Label.style.display = "block";

		// calculate lengths
		calcLenghts();

		// Place the result window
		document.getElementById("lengths").style.top = point2Y + 18;
		if( point2Y > ( screen.height - 100 ) ) document.getElementById("lengths").style.top = point2Y - 80;

		document.getElementById("lengths").style.left = point2X - 74;
		if( point2X < 75 ) document.getElementById("lengths").style.left = 0;
		if( point2X > screen.width - 80 ) document.getElementById("lengths").style.left = screen.width - 150;

		if( ruler == 0 ) document.getElementById("lengths").style.display = "block";
		else document.getElementById("lengths2").style.display = "block";

		points = 2;
	}
	else if( points == 2 ) {
		// clear the grid
		ctx.clearRect(0,0,screen.width,screen.height)
		document.getElementById("p1Coords").style.display = "none";
		document.getElementById("p2Coords").style.display = "none";
		document.getElementById("lengths").style.display = "none";
		document.getElementById("lengths2").style.display = "none";
		points = 0;
	}
}

function drawTempLine() {
	if( points == 1 ) {
		ctx.globalCompositeOperation="destination-out";
		ctx.lineWidth = 2;
		ctx.beginPath();
		ctx.moveTo(point1X,point1Y);
		ctx.lineTo(tempX,tempY);
		ctx.stroke();
		ctx.strokeRect( point1X - 2, point1Y - 2, 5, 5 );

		e = window.event;
		var xLen = point1X - e.x;
		if( xLen < 0 ) xLen = xLen * -1;
		var yLen = point1Y - e.y;
		if( yLen < 0 ) yLen = yLen * -1;

		if( ruler == 0 ) {
			if( !shiftKey ) {
				tempX = e.x;
				tempY = e.y;
			}
			else {
				if( xLen > yLen ) {
					tempX = e.x;
					tempY = point1Y;
				}
				else {
					tempX = point1X;
					tempY = e.y;
				}
			}
		}
		else {
			tempX = e.x;
			tempY = point1Y;
		}

		ctx.globalCompositeOperation = "source-over";
		ctx.strokeStyle = "rgba(127, 127, 127, 0.8)";
		ctx.lineWidth = 1;
		ctx.beginPath();
		ctx.moveTo(point1X,point1Y);
		ctx.lineTo(tempX,tempY);
		ctx.stroke();

		ctx.strokeStyle = "rgba(0, 0, 220, 1)";
		ctx.strokeRect( point1X - 2, point1Y - 2, 5, 5 );
	}
}

function calcLenghts() {
	var xLen = point1X - point2X;
	if( xLen < 0 ) xLen = xLen * -1;

	var yLen = point1Y - point2Y;
	if( yLen < 0 ) yLen = yLen * -1;


	var distance = Math.sqrt( ( xLen * xLen ) + ( yLen * yLen )  );
	distance = Math.round( distance * 10 ) / 10;

	lenLabel = document.getElementById("lengths");
	lenLabel.innerHTML = "Distance = " + distance + " px<br>X length = " + xLen + " px<br>Y length = " + yLen + " px";

	document.getElementById("lengths2").innerHTML = "Length: " + xLen + " px";
}
